'FFSubmenu=Entzerrung
'FFName=AutoKissenEntzerrung2
'FFFile=AutoKissenEntzerrung2.vbs

'' Author: Niels Nielsen,
'' 15-apr-2008 V. 1.14 , 

'' Basiert auf lteres Prototype und Hilfe von Jochen
'' und zeilweise basiert auf AldiBrennweite.js von Heinz Hfling 29.8.2004 V1.0
'' Wird ausgefhrt ber Boostskript  A-CallEnt2.js
'' Die zwei Skripte sind in FixFoto V. 2.84 B26-B61 entwickelt,
'' V. 1.03 sollten mit alle FixFoto seit V. 2.81 B09 bis V. 2.84 B85 funktionieren. 
''    (Ist doch nicht mit ltere V. geprft.)
'' V. 1.04 sollten mit alle FixFoto seit V. 2.84 B86 funktionieren,
''    vorausgesetzt dass Ordnerstruktur  \FixFoto\Params\  verwendet wird. 
'' V. 1.05  2-apr-2007 Kleinkorrektionen
'' V. 1.06 15-apr-2007 ISOkorrektion fr Casio1000
'' V. 1.08  5-jun-2007 22:11 Path fr wshshell.Run
'' V. 1.09  6-jun-2007  8:51 DSLR NIKON D40 eingetragen
'' V. 1.10 13-aug-2007 21:37 gendert zu funktionieren auch mit Canon PowerShot G7 
'' V. 1.11 30-sep-2007 11:06 Pfadfehler (war nur in Beschreibung) korrigiert 
'' V. 1.14 13-apr-2008 21:50 Funktioniert auch mit Vista, und auch mit U3-FixFoto
''                           !ILogFile02x.txt jetzt in c:\!LogAutoKissen2  wegend Vista

'' Prinzip :
''----------

'' 1. Es wird berprft dass den Korrektur nicht vorher mit diese Skript gemacht war. 
'' 2. Fals ein Aldi Traveler DC-5300 Bild, wird fehlende Brennweite erst in EXIF eingesetzt.
'' 3. Es wird untersucht, ist den Bild mit ein (in diese Skript bekanntes) DSLR gemacht, wenn ja wird ein
''    Korrekturdatei "Z MakeXObjektiv-size1xsize2.cff" ohne berprfung benutzt fals gefunden,
''    Beispiele siehe unten.
''    Sonst wird Korrekturdatei "Z MakeXObjektiv-size1xsize2.ff" ohne berprfung benutzt fals gefunden.
''    (size1 bedeutet Pixelgrsse des grsste  Seitenlnge zB 1600)
''    (size2 bedeutet Pixelgrsse des kleinste Seitenlnge zB 1200)
''    Man muss leider unterschiedliche Entzerrungprofile fr unterschiedliche Pixelgrsse machen.
''    Wenn keiner DSLR wird Korrekturdatei "Z Make Model-size1xsize2.cff" ohne berprfung benutzt fals gefunden.
''    sonst wird Korrekturdatei "Z Make Model-size1xsize2.ff" ohne berprfung benutzt fals gefunden.
'' 4. Wenn keine von diese Korrekturdateien gefunden wird, wird keine Korrektur gemacht.
'' 5. Skriptverlauf wird in ein LogDatei in selber Verzeichnis wo die Bilder liegen dokumentiert
''    mit OK oder Fehlermeldung von fehlendes Korrekturdatei / keine oder leere Exifdata.
''    Ohne korrekte EXIF-Data geht die Methode nicht.
''    Den LogDatei wird am Schirm gezeigt, man kann den LogDatei nachher lschen oder gespeichert lassen.
'' 6. Die resultierendes Bilder wird in Dateien mit ein nachgefgtes Buchstabe "k" gespeichert
''    gibt es schon ein Datei mit diese "k"-Name in Verzeichnis, wird es ohne Warnung gnadenlos berschrieben.
'' 7. Bootskript A-CallEnt2.js muss in Stapelverarbeitung als zweitletzte Zeile / Befehl stehen,
''    und direkt unten Bootskript A-CallEnt2.js in Stapelverarbeitung  MUSS  folgende Befehl stehen : 
''    Speichern als / Umbenennen  %lcx%%nam%k
'' 8. Bei ein Anzahl Kameraen zB von Canon, Casio und Nikon fehlen die ISO Werten in EXIF,
''    dieses wird in die "k" Ausgangsdateien repariert mit Hilfe von 'exiftool.exe' und 'Herstellerdaten'.


'' Einschrnkungen :
'' -----------------

'' Diese Skript ist nur fr  .jpg  Fotos gemacht, mit andere Bilder ist es nicht probiert.
'' Korrektion von Kissenentzerrung muss immer auf den volle Bild gemacht werden.
'' Beim Fehler wird Bild trotzdem gespeichert (ungendert nur neu komprimiert).
'' Jeder Modelle von DSLR  MUSS in Skript eingetragen werden.
'' Es fehlt Methode fr Wahl von zB Tele / Weitwinkel Konverter vor den Objektiv.
'' Es fehlt, fr DSLR, Methode fr Wahl von Tele / Weitwinkel Konverter hinten den Objektiv.
'' Es fehlt Methode fr DSLR fr sehr alte, besonderes Manuelles, Objektiven.
'' Einige auswechselbare Objektiven gibt mglicherweise selber Profilname, 
''   bitte stelle mir in diesen Fall Prfbilder zum sehen.
'' Es fehlt berprfung dass den verwendete FixFoto nicht zu alt ist 


'' Beispiele fr "Z Make Model" fur nicht DSLR Kameraen :
'' ------------------------------------------------------
'' "Z Panasonic DMC-FZ1"
'' "Z FUJIFILM FinePix S602 ZOOM" 
'' "Z KONICA MINOLTA DiMAGE A200"
'' "Z NIKON E4500" 
'' "Z Canon Canon PowerShot A200" 
'' "Z Canon Canon PowerShot G2"
'' "Z RICOH      Caplio R1V      " nach trim -> "Z RICOH Caplio R1V"
'' "Z CASIO QV-5700  "             nach trim -> "Z CASIO QV-5700"


'' Beispiele fr volle Namen fr Korrekturdateien fr Bilder von meiner FZ30 Kamera :
'' ----------------------------------------------------------------------------------

'' "Z Panasonic DMC-FZ30-3264x2448.cff"    4:3 Bild, 8 MP, 3264 x 2448 Pixel, Kissen und Farbsaumkorrektur
'' "Z Panasonic DMC-FZ30-1280x960.ff"      4:3 Bild, 1 MP, 1280 x 960  Pixel, nur Kissenkorrektur
'' "Z Panasonic DMC-FZ30-3248x2160.cff"    3:2 Bild, 7 MP, 3248 x 2160 Pixel, Kissen und Farbsaumkorrektur
'' "Z Panasonic DMC-FZ30-3248x2160.ff"     3:2 Bild, 7 MP, 3248 x 2160 Pixel, nur Kissenkorrektur
'' "Z Panasonic DMC-FZ30-1920x10.ff"    16:9 Bild, 2 MP, 1920 x 1080 Pixel, nur Kissenkorrektur
'' Insgesant gibt es 10 verschiedene Dateigrssen, dh 20 Korrekturdateien fr dieser Kamera,
''   aber wenn ein .cff Datei existiert wird den entsprechende .ff Datei nie benutzt.


'' Beispiele fr volle Namen fr Korrekturdateien (Profile) fr Bilder von DSLR's :
'' --------------------------------------------------------------------------------

'' Die Profilnamen fngt mit "Z "  an fr die meisten Kameraen
'' Die Profilnamen fngt mit "ZF " an fr Vollformat Kameraen mit Wechseloptik (DSLR's)

'' "Z NIKON AF-S VR Zoom-Nikkor 24-120mm f 3p5-5p6G IF-ED-3008x2000.ff"      , nur Kissenkorrektur
'' "Z PENTAX smc PENTAX-DA 16-45mm F4 ED AL-3872x2592.cff"                   , Kissen und Farbsaumkorrektur
'' "Z Canon EF24-105mm f 4L IS USM-4368x2912.ff"                             , nur Kissenkorrektur
'' "Z Canon 17p0 - 35p0mm (35mm equivalent 26p4 - 54p3mm)-1536x1024.cff"     , Kissen und Farbsaumkorrektur
'' "ZF Canon EF24-105mm f 4L IS USM-4368x2912.ff"                            , nur Kissenkorrektur, Vollformat
'' "ZF Canon 100p0 - 400p0mm (35mm equivalent 96p0 - 383p9mm)-2496x1664.ff"  , nur Kissenkorrektur, Vollformat
'' "Z SONY KonicaMinolta or Sony AF DT 18-70mm F3p5-5p6 (D)-768x514.ff"      , nur Kissenkorrektur

'' Leider kann den Skript von ein Bild nicht explicit feststellen,
'' das den Bild mit ein DSLR gemacht ist, jeder DSLR  MUSS deshalb in den Skript eingetragen werden,
'' gefundene Objektivname wird in Exif eingetragen von V 1.03
'' Zeichen "/" ist nicht in Dateinamen erlaubt, und ist mit " " (Leerzeichen) ergnzt.
'' Zeichen "." und "," sind nicht in Dateinamen erlaubt, und ist mit "p" in die DSLR's ergnzt.
''         in die non DSLR's wird "." zu "" und "," zu " "
'' Zeichen "*" ist nicht in Dateinamen erlaubt, und ist mit "x" ergnzt.
'' Zeichenfolge " - " ist mit "-" ergnzt.


'' 06-jun-2007 7:13 in Skript bekannte DSLR's :
'' --------------------------------------------

''   Halbformat Kameraen :
''   ---------------------
''   Canon Canon EOS 10D
''   Canon Canon EOS 20D
''   Canon Canon EOS 300D DIGITAL                            
''   Canon Canon EOS 350D DIGITAL                            
''   Canon Canon EOS 400D DIGITAL
''   NIKON CORPORATION NIKON D40
''   NIKON CORPORATION NIKON D50
''   NIKON CORPORATION NIKON D70
''   NIKON CORPORATION NIKON D70s
''   NIKON CORPORATION NIKON D80
''   NIKON CORPORATION NIKON D100
''   NIKON CORPORATION NIKON D200
''   NIKON CORPORATION NIKON D2Xs
''   KONICA MINOLTA DYNAX 5D
''   SONY DSLR-A100
''   PENTAX Corporation PENTAX K10D
''   PENTAX Corporation PENTAX K100D
'
''   Vollformat Kameraen :
''   ---------------------
''   Canon Canon EOS 5D

''   4:3 Kameraen :
''   --------------
''   OLYMPUS IMAGING CORP. E-330
''   OLYMPUS IMAGING CORP. E-500


'' Skript Installation :
'' ---------------------

'' ffne herunterladende Datei "kissen-vxxx.zip", 
'' kopiere den Ordner "FixFoto" von den .zip Datei ber den FixFoto Installationsordner,
'' zB "c:\Programme\FixFoto", hierbei wird smtliche notwendige Hilfsdateien zu die korrekte Ordner kopiert,
'' Vorausgesetzt, das man den FixFoto Installationsmethode mit "Params" gewhlt hat.


'' Notwendige Hilfs - Dateien :
'' ----------------------------

'' exiftool.exe  V. 6.66      in FixFoto Paramsverzeichnis        zB c:\Programme\FixFoto\Params
'' Paddy.*    4 Dateien       in FixFoto Paramsverzeichnis        zB c:\Programme\FixFoto\Params
'' Z*.ff und Z*.cff           in FixFoto Paramsverzeichnis        zB c:\Programme\FixFoto\Params
'' A-CallEnt2.js              in FixFoto Boostverzeichnis         zB c:\Programme\FixFoto\Params\BatchScript\Boost
'' AutoKissenEntzerrung2.vbs  in FixFoto Scriptverzeichnis        zB c:\Programme\FixFoto\Params\Script
'' Fotograf Yrsa.fbi          in FixFoto Batchsverzeichnis        zB c:\Programme\FixFoto\Params\Batch
'' *.jpg  Bilder              in FixFoto TestBilderverzeichnis    zB c:\TestBilder

''   exiftool.exe und Paddy sind freeware Programs, 
''     die ohne Installation benutzt wird, und sie machen keine Eintrge in den XP Registrierungsdatenbank.
''     Verschiedene Versionen von exiftool sind geprft, die verwendete ist V. 6.66
''   Die mitgelieferte .ff und .cff Profile zum Skript, sind meine echte Korrektions Profile.


'' Skript Benutzung :
'' ------------------

'' Start Programm FixFoto in gewnschten Verzeichnis - Bilder whlen - F12 - Fotograf Yrsa anrufen


'' Wie erstellt man selber eine Entzerrungsprofile ??
'' --------------------------------------------------

'' In gewhnliches Weise in FixFoto, ffne FixFoto -> Extras -> Objektivkorrektur
'' (es gibt zZ zwei Fehler/Ungenauigkeiten in den Bedienungsanleitung, 
''  um eine Messblatt fr 3:2 Kameraen, muss man Shift nicht Strg Drcken whrend den Drucken ,
''  und man muss den zuerst gemachte .ff Profil laden vor man den .cff Profil machen kann.)
'' Wenn ein Profile gemacht ist, muss es auf die genau richtige Name umbenennt werden :
'' ffne FixFoto - whlt eine Foto von gewnschte Kamera und Auflsung -
''    Taste F12 drcke - Fotograf Yrsa anrufen - Fehlermeldung am Ausgangsschirm zeigt genaue richtige Name
''    die Name fngt mit eine Buchstabe Z  an und geht zum Ende des Zeiles, (eignet fr Kopie - Einfgen),
''       bei DSLR Vollformat fngt es mit die Buchstaben ZF an und geht zum Ende des Zeiles.


'-------------------------------------------------------------------------------------------------------------------
'' Hier fngt den Skript an :
'-------------------------------------------------------------------------------------------------------------------

dim ordnerb, nameb, text, MakeKameraPSize, Cut, datei7, DSLR, zzz, zzza, exte
dim MakeKamera, PSize, korr, Makex, MakexFF, Make, KFormat, ISO, ISOcorr
dim obild6, file0, nos, lastfile, newname

JederBild

' MsgBox "obild6 : " & obild6 & chr(13) & "file0 : " & file0

if obild6 = file0 then                                      '' erster Bild
  ErsterBild
end if

                                                            '' jeder Bild
thisname = CheckName(obild6)
obild6 = """" & obild6 & """"
datei1 = "c:\!LogFile02cut.txt"

set fs = CreateObject ("Scripting.FileSystemObject")
if fs.FileExists(datei1) then
  Cut = -1
end if


Entzer "Det enkelte billede"                                '' dieses Rutine macht den Arbeit, siehe unten


set fs = CreateObject("Scripting.FileSystemObject")
set logbuch = fs.OpenTextFile(ordnerb & "\!LogFile02.txt", 8, true)
nameb1 = nameb + "                     "
if len(nameb)< 22 then
  nameb2 = mid(nameb1,1,22)
else
  nameb2 = mid(nameb, 1, 5) & "--" & mid(nameb, len(nameb) - 14, 15)
end if

                                
if fs.FileExists(ordnerb + nameb) then                      '' lscht Datei mit Namenschluss "k" wenn schon da
  fs.DeleteFile (ordnerb & nameb), true
end if

' MsgBox "nameb2 b : " & nameb2 & chr(13) & "text : " & text & chr(13) & "MakeKameraPSize : " &  MakeKameraPSize'' test


if DSLR = "yes" then
  len1 = len(Makex & datei7 & "-" & PSize & Exte)
  datei8 = string(90-len1," ")
  text = text & MakeKamera & " " & chr(13) & chr(10) & datei8 & Makex & datei7 & "-" & PSize
' MsgBox "text 3 : " & text & chr(13) & " text : " & text   '' test
  text=CheckName1(text)
' MsgBox "text 4 : " & text & chr(13) & " exte : " & exte   '' test
  text = text & Exte
else
  if text = "nicht korrigiert - keine oder leere Exif Daten in Bild" then
  elseif text = "nicht korrigiert - KissenEntzerrung schon vorher gemacht" then
  elseif text = "nicht korrigiert - keine oder leere Exif Daten in Bild" then
  else
'   text = text & MakeKameraPSize & Exte              ' ndret 16 mar 2007 NCN
    text = text & CheckName2(MakeKameraPSize) & Exte  ' ndret 16 mar 2007 NCN
'   MsgBox "text 5 : " & text & chr(13) & " exte : " & exte   '' test
  end if
end if
text = replace(text,"/"," ")
text = replace(text,":","")
text = replace(text,"*","x")


logbuch.WriteLine nameb2 & "  " & "  " & text 
logbuch.close

' MsgBox "exte c : " & exte      '' test
' MsgBox "obild6 c : " & obild6 & chr(13) & " lastfile : " & lastfile & chr(13) & " datei : " & datei      '' test

if obild6 = lastfile then                                   '' nach letzten Bild
  set fs = CreateObject ("Scripting.FileSystemObject")
  datei = ordnerb & "\!LogFile02.txt"
  if fs.FileExists(datei) then
    set wshshell = CreateObject("WScript.Shell")

'   MsgBox "Path  : " & g_ffpath & chr(13) & "mmm  : " & mmm

'   wshshell.Run g_ffpath & "\" & "paddy.exe " & ordnerb & "\!LogFile02.txt" , , -1
'   wshshell.Run "paddy.exe " & ordnerb & "\!LogFile02.txt" , , -1

'   g_ffpath1 = FF_GetFFPath()
    g_ffpath1 = FF_GetFFPathEx(1)  '' 12-apr-2008 12:15

'   MsgBox "Path  : " & g_ffpath1 & chr(13) & "mmm  : " & mmm

'   MsgBox "paddy  : " & g_ffpath1 & "\paddy.exe " & ordnerb & "\!LogFile02.txt"

'   wshshell.Run g_ffpath1 & "\Params\" & "paddy.exe " & ordnerb & "\!LogFile02.txt" , , -1
    wshshell.Run g_ffpath1 & "\paddy.exe " & ordnerb & "\!LogFile02.txt" , , -1  '' 12-apr-2008 12:15

    do
      ergebnis = 8
      ergebnis = FF_MessageBox(" Willst du den Log Datei jetzt lschen ?? ", vbYesNo)
      if ergebnis = vbYes then
        set fs = CreateObject ("Scripting.FileSystemObject")
        datei = ordnerb & "\!LogFile02.txt"
        if fs.FileExists(datei) then
          fs.DeleteFile datei, true
        end if
        datei1 = "c:\!LogFile02cut.txt"
        if fs.FileExists(datei1) then
          fs.DeleteFile datei1, true
        end if
      else
      end if
    loop while ergebnis=8
  end if
  FF_Reload
end if


'-----------------------------------

function CheckName(path)
  path = replace(path,"""","")
  set fs = CreateObject("Scripting.FileSystemObject")
  name = fs.GetBaseName(path)
  extension = fs.GetExtensionName(path)
  ordner = left(path, InstrRev(path, "\"))
  counter = 0
  ordnerb = ordner
  nameb = name & "k." & extension
  CheckName = path
end function
'---------------------------

function CheckName1(path)

  CheckName1= replace(path," . ","p")
  CheckName1= replace(CheckName1,".","p")
  CheckName1= replace(CheckName1,"*","x")

end function
'---------------------------

function CheckName2(path)

  CheckName2= replace(path," . ","")
  CheckName2= replace(CheckName2,".","")
  CheckName2= replace(CheckName2,","," ")

end function

'---------------------------
''                                                          '' hier wird den Arbeit gemacht
sub Entzer(was)


obild6=FF_GetParam()                                        '' undokumentiertes Dateiname
obild6 = """" & obild6 & """"
 
mmm = len(Make)
if mmm = 0 then                                             '' keine Exif 
else                                                        '' gibts Exif
  zz1 = FF_GetExifTag("Software")
  Software = zz1
  found = instr(zz1,"KissenEntzerrung")
  if found > 0 then
    kk = "schon Kissen"
  else
    kk = "noch nicht Kissen"
    Kamera = trim(FF_GetExifTag("Model"))
    Kamera = replace(Kamera,"/"," ")
    Kamera = replace(Kamera,":","")
    Kamera = replace(Kamera,"*","x")
    MakeKamera = "Z " & Make & " " & Kamera
  end if
end if


LSeite = FF_GetImageWidth
KSeite = FF_GetImageHeight
if LSeite < KSeite then
  KSeite = FF_GetImageWidth
  LSeite = FF_GetImageHeight
end if
PixSize = LSeite * KSeite

' MsgBox "MakeKamera : " & MakeKamera & chr(13) & "obild6  : " & obild6

DSLRNamen


if DSLR = "yes" or ISO = "" then                                      '' ja DSLR oder ISO "Wert missing
  set wshshell = CreateObject("WScript.Shell")
  set fs = CreateObject ("Scripting.FileSystemObject")

  if fs.FileExists("c:\!logAutoKissen2\!LogFile02x.txt") then   ' 13-apr-2008 20:35
'       MsgBox " stop 1 : " 
  else
    fs.CreateFolder("c:\!logAutoKissen2")
'       MsgBox " stop 2 : " 
  end if

  if fs.FileExists("c:\!logAutoKissen2\!LogFile02x.txt") then      ' 13-apr-2008 20:36
    fs.DeleteFile "c:\!logAutoKissen2\!LogFile02x.txt", true       ' 13-apr-2008 20:36
  end if
  obild6 = replace(obild6,"/"," ")
' obild6 = replace(obild6,":","")
' obild6 = replace(obild6,".","+")

  fileb1 = "c:\!logAutoKissen2\!LogFile02x.txt"                    ' 13-apr-2008 20:37
  fileb1c = "c:\!logAutoKissen2\!LogFile02x%c.txt"                 ' 13-apr-2008 20:37

'   MsgBox " exiftool : " & g_ffpath & "\exiftool " 

'   g_ffpath0 = FF_GetFFPath()
    g_ffpath0 = FF_GetFFPathEx(1)                                 '' 12-apr-2008 12:15




'   MsgBox " exiftool : " & g_ffpath0 & "\exiftool " 

' MsgBox "Path  : "& g_ffpath0 & "\" & "exiftool " & obild6 & "  -w " & fileb1c  & chr(13) & "mmm  : " & mmm

  wshshell.Run g_ffpath0 & "\" & "exiftool " & obild6 & "  -w " & fileb1c , , -1              
  set wshshell = nothing

'   MsgBox " fileb1 : " & fileb1
'   MsgBox " Make : " & Make  & chr(13) & " ISOcorr : " & ISOcorr & chr(13) & "datei7 : " & datei7 

  c20 = 0
  set datei2 = fs.OpenTextFile(fileb1)
  datei6 = "xx34567"
  do until datei2.atEndOfStream
    datei3 = datei2.ReadLine

    if ISO = "" then
      if c20=1 then      
      end if
      if Kamera = "Canon PowerShot G7" then
'         MsgBox " Kamera : " & Kamera  
        if left(datei3, 8) ="Auto ISO" then
          ISOcorr = trim(mid(datei3,34))
        end if
      elseif Make = "Canon" then
        if left(datei3, 8) ="Base ISO" then
          ISOcorr = trim(mid(datei3,34))
        end if
      elseif Make = "NIKON CORPORATION" then
        if trim(left(datei3, 18)) ="ISO" then
          ISOcorr = trim(mid(datei3,34))
        end if
      elseif Make = "CASIO COMPUTER CO.,LTD" or Make = "CASIO COMPUTER CO.,LTD." then
        if left(datei3, 19) ="CCD ISO Sensitivity" then
'          MsgBox " datei3 : " & datei3  & chr(13) & " mid(datei3,33,5) : " & mid(datei3,33,5) & chr(13) & "datei7 : " & datei7 
          ISOcorr = trim(mid(datei3,34))
        end if
      elseif Make = "CASIO" then
        if left(datei3, 15) ="CCD Sensitivity" then
'         MsgBox " datei3 : " & datei3  & chr(13) & " mid(datei3,34,3) : " & mid(datei3,34,4) & chr(13) & "datei7 : " & datei7 
          if trim(mid(datei3,34)) = "High (or ISO 100)" then
            ISOcorr = "100"
          elseif trim(mid(datei3,34,4)) = "ISO" then
            ISOcorr = trim(mid(datei3,38))
          end if
        end if
      else
      end if
    end if

'   MsgBox " Make : " & Make  & chr(13) & " ISOcorr : " & ISOcorr & chr(13) & "datei7 : " & datei7 



'   if MakeKamera = "Z Canon Canon EOS 20D" or MakeKamera = "Z Canon Canon EOS 10D" or MakeKamera = "Z Canon Canon EOS D60" then
    if left(MakeKamera,17) = "Z Canon Canon EOS" then  ' ny 16 jan 2007
      if left(datei3, 4) ="Lens" then
        c20 = c20 +1
        datei6 = left(datei3, 4)
        datei7 = mid(datei3,34)
'       MsgBox "c20 : " & c20 & chr(13) & "datei6 : " & datei6  & chr(13) & "datei7 : " & datei7 
      end if    
    elseif trim(left(datei3, 30)) = "Max Aperture Value" then  ' glemt for hvilket kamera / objektiv
      datei7c = trim(mid(datei3,34)) & "-"
    elseif MakexFF = "yes" then   ' Olympus DSLR schon vorher in FixFoto gespeichert
      if trim(left(datei3, 30)) = "Max Aperture At Max Focal" then
        datei7d = trim(mid(datei3,34))
      elseif trim(left(datei3, 30)) = "Min Focal Length" then
        datei7a = trim(mid(datei3,34)) & "-"
      elseif trim(left(datei3, 30)) = "Max Focal Length" then
        datei7b = trim(mid(datei3,34)) & "mm F"
      elseif trim(left(datei3, 30)) = "Max Aperture At Current Focal" then    
        '' datei7c = trim(mid(datei3,34)) & "-"  '' falsch 
        datei7 = datei7 & datei7a & datei7b & datei7c & datei7d 
'       MsgBox " datei6 : " & datei6 & chr(13) & "datei7 : " & datei7 
      end if
    else
      if left(datei3, 7) ="Lens ID" then
'       MsgBox " datei3 a : " & datei3 & chr(13) & " mid(datei) : " & mid(datei3,35,9)
        if mid(datei3,35,9) = "Unknown (" then  ' for Nikon D100 med AF Nikkor 35-105mm 1:3.5-4.5 D
'         MsgBox " datei3 b : " & datei3
          datei3 = datei2.ReadLine
'         MsgBox " datei3 b : " & datei3
        end if
        datei6 = left(datei3, 7)
        datei7 = mid(datei3,34)
      elseif left(datei3, 9) ="Lens Type" then

'       MsgBox " mid(datei3,34,42) : " & mid(datei3,34,42)  & chr(13) & " datei6 : " & datei6 & chr(13) & "datei7 : " & datei7 


        if Makex ="Z OLYMPUS" then
          if trim(mid(datei3,34,22)) = "Olympus Zuiko Digital" then
            datei6 = left(datei3, 9)
            datei7 = mid(datei3,34)
'         elseif trim(mid(datei3,34,42)) = "Unknown Make (229) Unknown Model (229 159)" then
          elseif trim(mid(datei3,34,13)) = "Unknown Make" then
            MakexFF = "yes"
            datei6 = left(datei3, 9)
            datei7 = " ? "
          else
''          MsgBox " mid(datei3,34,42) : " & mid(datei3,34,42)  & chr(13) & " datei6 : " & datei6 & chr(13) & "datei7 : " & datei7 
          end if
        else
          datei6 = left(datei3, 9)
          datei7 = mid(datei3,34)
        end if
      end if
    end if
    datei7 = replace(datei7,"/"," ")
    datei7 = replace(datei7,":","")
    datei7 = replace(datei7,"*","x")
  loop


  if ISO = "" then
    FF_SetExifTag "ISOSpeedRatings",ISOcorr
'   MsgBox " Make : " & Make  & chr(13) & " ISOcorr : " & ISOcorr & chr(13) & "datei7 : " & datei7 
  end if

' MsgBox "datei3 : " & datei3 & chr(13) & "datei6 : " & datei6 & chr(13) & "datei7 : " & datei7
  datei2.close
end if  ' DSLR = "yes"
set fs = nothing




    
if MakeKamera = "Z CAMERA 5MP-9A3" then                     '' Aldi Traveler DC-5300
  if FF_GetExifTag("FocalLength") = "" then
    if FF_GetExifTag("FocalLengthIn35mmFilm") <> "" then
      focal = FF_GetExifTag("FocalLengthIn35mmFilm") / 4.861111
      FF_SetExifTag "FocalLength", focal
    end if
  end if
end if

' MsgBox "Path  : " & FF_GetFFPath() & chr(13) & "mmm  : " & mmm
      
if kk = "schon Kissen" then                                 '' KissenEntzerrung schon gemacht
  text = "nicht korrigiert - KissenEntzerrung schon vorher gemacht"
elseif mmm <> 0 then                                        '' es gibt Exif 
  g_ffpath = FF_GetFFPath()


  g_ffpath = FF_GetFFPathEx(1)



end if

PSize = LSeite & "x" & KSeite
MakeKameraPSize = MakeKamera & "-" & PSize
KorrFile1 = CheckName1(KorrFile)


' MsgBox "KorrFile  : " & KorrFile & chr(13) & "KorrFile1  : " & KorrFile1

set fs = CreateObject("Scripting.FileSystemObject")


if DSLR = "yes" then
  KorrFileS = CheckName1(Makex & datei7 & "-" & PSize)
  KorrFileX = trim(datei7 & "-" & PSize)
  AltKommentar = FF_GetExifTag("UserComment")
  NeuKommentar = "Lens & size used : " & KorrFileX & chr(13) & chr(10)& AltKommentar

' MsgBox "KorrFileX  : " & KorrFileX & chr(13) & "AltKommentar : " & AltKommentar & chr(13) & "NeuKommentar : " & NeuKommentar

  foundK = instr(AltKommentar,"Lens & size used :")
  if foundK > 0 then
    ' schon gemacht
  else
    FF_SetExifTag "UserComment",NeuKommentar
  end if



  KorrFile = KorrFileS & ".cff"
  KorrFileFF = KorrFileS & ".ff"
' MsgBox "KorrFile 1 : " & KorrFile & chr(13) & "KorrFileFF 1 : " & KorrFileFF

else
' KorrFile = MakeKamera & datei7 & "-" & PSize & ".cff"       ' ndret 31 jan 2007 NCN
' KorrFileFF = MakeKamera & datei7 & "-" & PSize & ".ff"      ' ndret 31 jan 2007 NCN
' KorrFileFF = MakeKamera & datei7 & "-" & PSize & ".ff"      ' ndret 31 jan 2007 NCN
' MsgBox "KorrFile 1da : " & KorrFile & chr(13) ' & "zzz : " & zzz
' KorrFile = MakeKamera & "-" & PSize & ".cff"                       ' ndret 16 mar 2007 NCN
' KorrFile = CheckName2(MakeKamera & datei7 & "-" & PSize) & ".cff"  ' ndret 16 mar 2007 NCN
  KorrFile = CheckName2(MakeKamera & "-" & PSize) & ".cff"           ' ndret 15 apr 2007 NCN
' KorrFileFF = MakeKamera & "-" & PSize & ".ff"                      ' ndret 16 mar 2007 NCN
' KorrFileFF = CheckName2(MakeKamera & datei7 & "-" & PSize) & ".ff" ' ndret 16 mar 2007 NCN
  KorrFileFF = CheckName2(MakeKamera & "-" & PSize) & ".ff"          ' ndret 15 apr 2007 NCN
  KorrFileX = trim(MakeKamera & "-" & PSize)
end if

exte = ".cff"
' MsgBox "KorrFile 1d : " & KorrFile & chr(13) ' & "zzz : " & zzz




' KorrFile =g_ffpath&"\Params\"+ KorrFile      ' gendert  2-apr-2007 23:39
' KorrFileFF =g_ffpath&"\Params\"+ KorrFileFF  ' gendert  2-apr-2007 23:39
KorrFile =g_ffpath&+"\"+ KorrFile                  ' gendert 12-apr-2008 10:56
KorrFileFF =g_ffpath+"\"+ KorrFileFF               ' gendert 12-apr-2008 10:56
' MsgBox "KorrFile 1d : " & KorrFile & chr(13) ' & "zzz : " & zzz




if mmm = 0 then
  korr = "nej"                                              '' keine Exif 
  text = "nicht korrigiert - keine oder leere Exif Daten in Bild"
elseif kk = "schon Kissen" then                             '' KissenEntzerrung schon gemacht
  korr = "nej"
elseif fs.FileExists(KorrFile) then
  zzz = FF_AutoColorBorder(KorrFile, Cut)                   '' macht Kissen+Farbsaumkor.
' MsgBox "KorrFile 1bbb : " & KorrFile & chr(13) & "zzz : " & zzz
  if zzz = true then
    Nys = FF_GetMajor() & "." & FF_GetMinor() & " B:" & FF_GetBuild()
'   NySoftware = "FixFoto(R) v" & Nys & " 'KissenEntzerrung und Farbsaum' " & " , " & now & chr(13) & chr(10) & Software  
'   NySoftware = "FixFoto(R) v" & Nys & " 'KissenEntzerrung und Farbsaum' " & " , " & KorrFile
'   NySoftware = NySoftware & " , " & now & chr(13) & chr(10) & Software  
''  NySoftware=CheckName1(NySoftware)
    NySoftware = "FixFoto(R) v" & Nys & " 'KissenEntzerrung und Farbsaum' , " & now & " , Profil :"
'   NySoftware = NySoftware &  chr(13) & chr(10) & KorrFileX & ".cff " &  chr(13) & chr(10) & Software  
'   gendert 14 apr 2007
    NySoftware = NySoftware &  chr(13) & chr(10) & CheckName2(KorrFileX) & ".cff " &  chr(13) & chr(10) & Software  
'   MsgBox "NySoftware : " & NySoftware
    FF_SetExifTag "Software", NySoftware
    text = "OK    korr   mit - " 
    exte = ".cff"
  else
    text = "nicht korrigiert - unbekannte Fehler, noch nie gesehen"
  end if   
else
  exte = ".ff"
' MsgBox "KorrFileFF 1c : " & KorrFileFF         ''       & chr(13) & "zzz : " & zzz

  if fs.FileExists(KorrFileFF) then
    zzza = FF_AutoPinCushion (KorrFileFF, Cut)              '' macht Kissenkorrektur
'   MsgBox "KorrFileFF 2 : " & KorrFileFF & chr(13) & "zzza : " & zzza
    if zzza = true then    
      Nys = FF_GetMajor() & "." & FF_GetMinor() & " B:" & FF_GetBuild()
'     NySoftware = "FixFoto(R) v" & Nys & " 'KissenEntzerrung' " & " , " & KorrFileFF
''    NySoftware=CheckName1(NySoftware)
      NySoftware = "FixFoto(R) v" & Nys & " 'KissenEntzerrung' , " & now & " , Profil :"
'     NySoftware = NySoftware &  chr(13) & chr(10) & KorrFileX  & ".ff , " & now &  chr(13) & chr(10) & Software  
'     gendert 14 apr 2007
      NySoftware = NySoftware &  chr(13) & chr(10) & CheckName2(KorrFileX)  & ".ff " &  chr(13) & chr(10) & Software  
      FF_SetExifTag "Software",NySoftware
'     MsgBox "KorrFileX : " & KorrFileX & chr(13) & "CheckName2(KorrFileX) : " & CheckName2(KorrFileX) 
      text = "OK    korr   mit - "
  end if
  else                                                      '' keine Korrekturdatei 
    korr = "nej"   
    text = "Korr Datei fehlt - " 
    exte = ".ff"
  end if
end if

end sub  ' Entzer

'-------------------------------------------------------------------------------------

Sub JederBild

Make = FF_GetExifTag("Make")                                '' jeder Bild
Make = trim(replace(Make,"/"," "))
Make = trim(replace(Make,":",""))
Make = trim(replace(Make,"*","x"))
ISO = trim(FF_GetExifTag("ISOSpeedRatings"))
'MsgBox " ISO :  " & ISO

nos = FF_GetImageCount()
file0 = FF_GetImageName(0)
file0 = """" & file0 & """"

idx = 1
lastfile = FF_GetImageName(nos-1)
lastfile = """" & lastfile & """"

obild6=FF_GetParam()
obild6 = """" & obild6 & """"
newname = CheckName(file0)
file0 = """" & file0 & """"

' MsgBox " obild6  first :  " & obild6 & chr(13) & " ordnerb  first :  " & ordnerb & chr(13) & " ordnerb  first :  " & ordnerb

end sub

' ------------------------------------------------------------------------------------

Sub ErsterBild

  set fs = CreateObject("Scripting.FileSystemObject")
  set logbuch = fs.OpenTextFile(ordnerb & "\!LogFile02.txt", 8, true)
  logbuch.WriteLine string(101, "=")
  logbuch.WriteLine " Niels Nielsen, AutoKissenEntzerrung2  " & now &  "      weiter mit Tastendruck  ESC "
  logbuch.WriteLine " Verzeichnis  " & ordnerb
  logbuch.WriteLine " Dateiname                Ergebnis             Kamera               .cff oder .ff  Profile"
  logbuch.WriteLine string(101, "-")
  logbuch.WriteLine " "
  logbuch.close

                                                            '' beschneiden nach Korrektur ?
  Cut = 0 

  do
    ergebnis1 = 8
    ergebnis1 = FF_MessageBox(" Automatisch Bildseitebeschneidung  ?? ", vbYesNo)
    if ergebnis1 = vbYes then
      Cut = -1
      thisname1 = CheckName(obild6)
      obild6 = """" & obild6 & """"
      set fs = CreateObject ("Scripting.FileSystemObject")
      datei1 = "c:\!logAutoKissen2\!LogFile02cut.txt" 
'     MsgBox "datei1 : " & datei1 
'     set logbuchcut = fs.OpenTextFile(datei1, 8, true)     '' make signalfile at first Picture
'     MsgBox " datei1 :  " & datei1 & chr(13) & " ergebnis1 :  " & ergebnis1
'     if fs.FileExists(datei1) = -1 then
'       logbuchcut.WriteLine string(101, "=")
'       logbuchcut.WriteLine " Niels Nielsen, AutoKissenEntzerrung2  , automatisch Bildseitebeschneidung " & now
'       logbuchcut.WriteLine " "
'       logbuchcut.close
'     end if
    else
      set fs = CreateObject ("Scripting.FileSystemObject")
'     datei1 = ordnerb & "\!LogFile02cut.txt"
      datei1 = "c:\!logAutoKissen2\!LogFile02cut.txt"
      if fs.FileExists(datei1) then
        fs.DeleteFile datei1, true                          '' delete signalfile
      end if
    end if
  loop while ergebnis1=8

end sub ' ErsterBild

'----------------------------------------------------------------------------------

Sub DSLRNamen

  DSLR = "yes"
  KFormat = "half"

  select case MakeKamera
    case "Z PENTAX Corporation PENTAX K10D"                           '' Pentax K10D
      Makex = "Z PENTAX"
    case "Z PENTAX Corporation PENTAX K100D"                          '' Pentax K100D
      Makex = "Z PENTAX"
    case "Z Canon Canon EOS 400D DIGITAL"                             '' Canon EOS 400D
      Makex = "Z Canon"
    case "Z Canon Canon EOS 350D DIGITAL"                             '' Canon EOS 350D
      Makex = "Z Canon"
    case "Z Canon Canon EOS 300D DIGITAL"                             '' Canon EOS 300D
      Makex = "Z Canon"
    case "Z Canon Canon EOS 20D"                                      '' Canon EOS 20D
      Makex = "Z Canon"
    case "Z Canon Canon EOS 10D"                                      '' Canon EOS 10D
      Makex = "Z Canon"
    case "Z Canon Canon EOS 5D"                                       '' Canon EOS 5D
      KFormat = "full"
      Makex = "ZF Canon"
    case "Z Canon Canon EOS D60"                                      '' Canon EOS D60
      Makex = "Z Canon"
    case "Z NIKON CORPORATION NIKON D40"                              '' Nikon D40
      Makex = "Z NIKON"
    case "Z NIKON CORPORATION NIKON D50"                              '' Nikon D50
      Makex = "Z NIKON"
    case "Z NIKON CORPORATION NIKON D70"                              '' Nikon D70
      Makex = "Z NIKON"
    case "Z NIKON CORPORATION NIKON D70s"                             '' Nikon D70s
      Makex = "Z NIKON"
    case "Z NIKON CORPORATION NIKON D80"                              '' Nikon D80
      Makex = "Z NIKON"
    case "Z NIKON CORPORATION NIKON D100"                             '' Nikon D100
      Makex = "Z NIKON"
    case "Z NIKON CORPORATION NIKON D200"                             '' Nikon D200
      Makex = "Z NIKON"
    case "Z NIKON CORPORATION NIKON D2Xs"                             '' Nikon D2Xs
      Makex = "Z NIKON"
    case "Z KONICA MINOLTA DYNAX 5D"                                  '' Ko-Mi 5D
      Makex = "Z KoMi"
    case "Z SONY DSLR-A100"                                           '' Sony-A100
      Makex = "Z SONY"
    case "Z OLYMPUS IMAGING CORP. E-500"                              '' Olympus E-500
      Makex = "Z OLYMPUS"
    case "Z OLYMPUS IMAGING CORP. E-330"                              '' Olympus E-330
      Makex = "Z OLYMPUS"
    case else                                              '' nicht ein bekannter DSLR
      DSLR = "no"
      Makex = ""
  end select  ' MakeKamera

end sub  ' DSLRNamen

'----------------------------------------------------------------------------------

'----------------------------------------------------------------------------------

'----------------------------------------------------------------------------------

'----------------------------------------------------------------------------------

'' end of whole script program -------------------------------------------------------
